/*
  CPP_CONTEST=2019Enero
  CPP_PROBLEM=A
  CPP_LANG=CPP+OPENMP
  CPP_PROCESSES_PER_NODE=calisto 1
*/

#include <stdio.h>
#include <stdlib.h>
#include <omp.h>

extern void escribir(char *,int,int);

void distancia(int n,int row,int column, char *A,int *D)
{
    int distancia=0;
    int paso=1;
    int encontrado=0;
    char elemento=A[row*n+column];
    int rowact,columnizq,columnder; 
    while(!encontrado && paso!=(2*n-1))
    {
       for(rowact=row-paso,columnizq=column,columnder=column;!encontrado && rowact<=row;rowact++,columnizq--,columnder++)
       {
          if((rowact>=0) && ((columnizq>=0 && elemento==A[rowact*n+columnizq]) || (columnder<n && elemento==A[rowact*n+columnder])))
          {
            encontrado=1;
            distancia=paso;
          }
       }
      for(rowact=row+1,columnizq=column-paso+1,columnder=column+paso-1;!encontrado && rowact<=row+paso;rowact++,columnizq++,columnder--)
       {
          if((rowact<n) && ((columnizq>=0 && elemento==A[rowact*n+columnizq]) || (columnder<n && elemento==A[rowact*n+columnder])))
          {
            encontrado=1;
            distancia=paso;
          }
       }
       paso++;
    }
    D[row*n+column]=distancia;
}

void escribirint(int *m, int N,int M) {
  int i, j;

  for (i = 0; i < N; i++) {
    for (j = 0; j < M; j++)
      printf("%d ", m[i * M + j]);
    printf("\n");
  }
  printf("\n");
}

int sumar(int n,int *m)
{
  int s=0;
   #pragma omp parallel for reduction(+:s) 
  for(int i=0;i<n;i++)
    s+=m[i];
  return s;
}

int  sec(int n,char *A)
{
  int *D=(int*) calloc(sizeof(int),n*n);
  int result;
  int i,j;
  #pragma omp parallel for schedule(dynamic,1) private(i,j)
  for (i = 0; i <n; i++)
  {
     for(j=0;j<n;j++)
     {
        distancia(n,i,j,A,D);
     }
  }
#ifdef DEBUG
    escribirint(D,n,n);
#endif
  result=sumar(n*n,D);
  delete[] D;
  return result;
}

