/*
  CPP_CONTEST=2019Enero
  CPP_PROBLEM=C
  CPP_LANG=CPP+OPENMP+MPI
  CPP_PROCESSES_PER_NODE=calisto 1
*/

#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>
#include <omp.h>

#define NTHREADS 4

extern void escribir(char *,int,int);

void distancia(int n,int row,int column, char *A,int rowD,int *D)
{
    int distancia=0; //guarda la distancia, si no lo encuentra es 0
    int paso=1; //indica el paso por el que vamos
    int encontrado=0; //indica si se ha encontrado
    char elemento=A[row*n+column]; //elemento con el que vamos a comparar
    int rowact,columnizq,columnder; //en cada paso: fila actual, columnas a izquierda y derecha de la que vamos
    while(!encontrado && paso!=(2*n-1)) //hay un numero maximo de pasos. Si se encuentra se sale
    {
       for(rowact=row-paso,columnizq=column,columnder=column;!encontrado && rowact<=row;rowact++,columnizq--,columnder++)
//el paso indica cuantas filas por arriba, la primera vez estamos en la misma columna, tanto a izquierda como a derecha
//si se encuentra se acaba, o si se llega a la fila actual
//se va bajando de fila y la columna izquierda se hace una a la izquierda y la derecha una a la derecha
       {
          if((rowact>=0) && ((columnizq>=0 && elemento==A[rowact*n+columnizq]) || (columnder<n && elemento==A[rowact*n+columnder])))
//si no nos salimos de la matriz por arriba y
//no se sale la columna izquierda y coincide con el elemento, o no se sale la columna derecha y coincide con el elemento
          {
            encontrado=1;
            distancia=paso;
          }
       }
      for(rowact=row+1,columnizq=column-paso+1,columnder=column+paso-1;!encontrado && rowact<=row+paso;rowact++,columnizq++,columnder--)
//se empieza en la fila de abajo, la primera vez estamos paso-1 columnas mas a la izquierda y a la derecha
//si se encuentra se acaba, o si se llega a la fila actual mas el paso por el que vamos
//se va bajando de fila y la columna izquierda se hace una a la derecha y la derecha una a la izquierda
       {
          if((rowact<n) && ((columnizq>=0 && elemento==A[rowact*n+columnizq]) || (columnder<n && elemento==A[rowact*n+columnder])))
          {
            encontrado=1;
            distancia=paso;
          }
       }
       paso++;
    }
    D[rowD*n+column]=distancia;
}

void escribirint(int *m, int N,int M) {
//solo para DEBUG
  int i, j;

  for (i = 0; i < N; i++) {
    for (j = 0; j < M; j++)
      printf("%d ", m[i * M + j]);
    printf("\n");
  }
  printf("\n");
}

int sumar(int n,int *m)
//suma todos los elementos del array
{
  int s=0;
  for(int i=0;i<n;i++)
    s+=m[i];
  return s;
}

int  sec(int n,char *A,int nodo,int np)
{
  MPI_Bcast(&n,1,MPI_INT,0,MPI_COMM_WORLD); //envio de n
  if(nodo!=0) //los distintos de 0 reservan espacio para A
    A=(char *) calloc(sizeof(char),n*n);
  MPI_Bcast(A,n*n,MPI_CHAR,0,MPI_COMM_WORLD); //envio de A a todos los procesos
  int inicio,final,tamano;//variables para almacenar donde trabaja cada proceso
  if(nodo<n%np)
  {
      tamano=n/np+1;
      inicio=nodo*tamano;
      final=inicio+tamano;
  }
  else
  {
      tamano=n/np;
      inicio=nodo*tamano+n%np;
      final=inicio+tamano;
  }
  int *D=(int*) calloc(sizeof(int),tamano*n);
  int result,result0=0;
  omp_set_num_threads(2);
  #pragma omp parallel for schedule(dynamic,1)
  for (int i = inicio; i <final; i++)
  {
     for(int j=0;j<n;j++)
     {
        distancia(n,i,j,A,i-inicio,D); //calcula la distancia para cada elemento
     }
  }
#ifdef DEBUG
    escribirint(D,n,n);
#endif
  result=sumar(tamano*n,D);
  MPI_Reduce(&result,&result0, 1,MPI_INT,MPI_SUM,0,MPI_COMM_WORLD); //se acumulan los resultados parciales
  delete[] D;
  return result0;
}

