/*
  CPP_CONTEST=2019Enero
  CPP_PROBLEM=D
  CPP_LANG=CPP+OPENMP
  CPP_PROCESSES_PER_NODE=calisto 1
*/

#include <stdio.h>
#include <stdlib.h>
#include <omp.h>

#define NTHREADS 4

extern void escribir(char *,int,int);

void escribirint(int *m, int N,int M) {
//solo para DEBUG
  int i, j;

  for (i = 0; i < N; i++) {
    for (j = 0; j < M; j++)
      printf("%d ", m[i * M + j]);
    printf("\n");
  }
  printf("\n");
}

int  sec(int n,char *C1,char *C2)
{
  int dim=n+1;//número de filas de tabla de programación dinámica
  int *T=(int*) calloc(sizeof(int),dim*dim);
//tabla para programación dinámica
//se pone a -1, que indica que nos e ha escribo. Para las comunicaciones entre hilos
  for(int i=0;i<dim*dim;i++)
    T[i]=-1;

  for(int i=0;i<dim;i++)
   //caso base fila
     T[i]=0;
  for(int i=1;i<dim;i++)
//caso base columna
     T[i*dim]=0;
#ifdef DEBUG
    escribirint(T,dim,dim);
#endif

  omp_set_num_threads(NTHREADS);
  #pragma omp parallel
  {
      int nodo=omp_get_thread_num();
      int np=omp_get_num_threads();
      int i,j; //índices para bucles
      int inicio,final,tamano; //inicio, final y tamaños locales para C2
      int recibido;//para comprobar si se ha calculado ya el valor anterior de la fila

      if(nodo<n%np)
      {
        tamano=n/np+1;
        inicio=nodo*tamano;
        final=inicio+tamano;
      }
      else
      {
        tamano=n/np;
        inicio=nodo*tamano+n%np;
        final=inicio+tamano;
      }

      if(nodo==0)
      {
        for (i = 1; i <dim; i++)
       {
         for(j=inicio+1;j<final+1;j++)
       {
//máximo de la fila y columna anterior
          int maximo=(T[(i-1)*dim+j]>T[i*dim+j-1]?T[(i-1)*dim+j]:T[i*dim+j-1]);
//si los elementos de las cadenas coinciden y añadiendo 1 al valor en la diagonal 
//anterior es mayor que el máximo, se actualiza
          if(C1[i-1]==C2[j-1] && T[(i-1)*dim+j-1]+1>maximo)
            maximo=T[(i-1)*dim+j-1]+1;
          T[i*dim+j]=maximo;
       }//for j
    }//for i
  } //if
  else if(nodo==np-1)
  {
    for (i = 1; i <dim; i++)
    {
       recibido=0;      
       while(!recibido)
       {       
         #pragma omp critical
         {
           if(T[i*dim+inicio]!=-1)
             recibido=1;
          }//critical
       }//while
       for(j=inicio+1;j<final+1;j++)
       {
//máximo de la fila y columna anterior
          int maximo=(T[(i-1)*dim+j]>T[i*dim+j-1]?T[(i-1)*dim+j]:T[i*dim+j-1]);
//si los elementos de las cadenas coinciden y añadiendo 1 al valor en la diagonal 
//anterior es mayor que el máximo, se actualiza
          if(C1[i-1]==C2[j-1] && T[(i-1)*dim+j-1]+1>maximo)
            maximo=T[(i-1)*dim+j-1]+1;
          T[i*dim+j]=maximo;
       }//for j
    }//for i
  } //if
  else 
  {
    for (i = 1; i <dim; i++)
    {
       recibido=0;      
       while(!recibido)
       {       
         #pragma omp critical
         {
           if(T[i*dim+inicio]!=-1)
             recibido=1;
          }//critical
       }//while
       for(j=inicio+1;j<final+1;j++)
       {
//máximo de la fila y columna anterior
          int maximo=(T[(i-1)*dim+j]>T[i*dim+j-1]?T[(i-1)*dim+j]:T[i*dim+j-1]);
//si los elementos de las cadenas coinciden y añadiendo 1 al valor en la diagonal 
//anterior es mayor que el máximo, se actualiza
          if(C1[i-1]==C2[j-1] && T[(i-1)*dim+j-1]+1>maximo)
            maximo=T[(i-1)*dim+j-1]+1;
          T[i*dim+j]=maximo;
       }//for j
    }//for i
  } //if
  }//parallel
#ifdef DEBUG
    escribirint(T,dim,dim);
#endif
//la longitud de la cadena más larga es el último valor en la tabla de programación dinámica
  return T[dim*dim-1];
}

