/*
  CPP_CONTEST=2019Enero
  CPP_PROBLEM=E
  CPP_LANG=CPP+MPI
  CPP_PROCESSES_PER_NODE=calisto 4
*/

#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>

extern void escribir(char *,int,int);

void escribirint(int *m, int N,int M) {
//solo para DEBUG
  int i, j;

  for (i = 0; i < N; i++) {
    for (j = 0; j < M; j++)
      printf("%d ", m[i * M + j]);
    printf("\n");
  }
  printf("\n");
}

int  sec(int n,char *C1,char *C2,int nodo,int np)
{
  MPI_Status * status; //para MPI_Recv
  int i,j; //índices para bucles
  int resul; //guarda el resultado
  int *sendcount,*senddisp;// en el 0 para contador y desplazamientos para distribuir C2
  MPI_Bcast(&n,1,MPI_INT,0,MPI_COMM_WORLD); //envio de n
  if(nodo!=0) //los distintos de 0 reservan espacio para C1
    C1=(char *) calloc(sizeof(char),n);
  MPI_Bcast(C1,n,MPI_CHAR,0,MPI_COMM_WORLD); //envio de C1 a todos los procesos
#ifdef DEBUG
    escribir(C1,1,n);
#endif

  int dim=n+1,dimloc;//número de filas, y número de columnas por proceso
  if(nodo<n%np)
  {
//una columna adicional para caso base y valores de proceso anterior
     dimloc=n/np+2;
  }
  else
  {
     dimloc=n/np+1;
  }
  if(nodo!=0) //los distintos de 0 reservan espacio para su trozo de C2
    C2=(char *) calloc(sizeof(char),dimloc-1);
  if(nodo==0)
  {
     sendcount=(int *) calloc(sizeof(int),np);
     senddisp=(int *) calloc(sizeof(int),np);
     for(int i=0;i<np;i++)
       sendcount[i]=(i<n%np?n/np+1:n/np);
     senddisp[0]=0;
     for(int i=1;i<np;i++)
        senddisp[i]=senddisp[i-1]+sendcount[i-1];
  }
  MPI_Scatterv(C2,sendcount, senddisp,MPI_CHAR, C2,dimloc,MPI_CHAR,0, MPI_COMM_WORLD);
#ifdef DEBUG
    escribir(C2,1,dimloc-1);
#endif

  int *T=(int*) calloc(sizeof(int),dim*dimloc);
//tabla para programación dinámica
  
  for(int i=0;i<dimloc;i++)
   //caso base fila
     T[i]=0;
  for(int i=1;i<dim;i++)
//caso base columna
     T[i*dimloc]=0;
#ifdef DEBUG
    escribirint(T,dim,dimloc);
#endif

  if(nodo==0)
  {
    for (i = 1; i <dim; i++)
    {
       for(j=1;j<dimloc;j++)
       {
//máximo de la fila y columna anterior
          int maximo=(T[(i-1)*dimloc+j]>T[i*dimloc+j-1]?T[(i-1)*dimloc+j]:T[i*dimloc+j-1]);
//si los elementos de las cadenas coinciden y añadiendo 1 al valor en la diagonal 
//anterior es mayor que el máximo, se actualiza
          if(C1[i-1]==C2[j-1] && T[(i-1)*dimloc+j-1]+1>maximo)
            maximo=T[(i-1)*dimloc+j-1]+1;
          T[i*dimloc+j]=maximo;
       }//for j
       MPI_Send(&T[i*dimloc+dimloc-1], 1, MPI_INT, 1,i, MPI_COMM_WORLD);
    }//for i
  } //if
  else if(nodo==np-1)
  {
    for (i = 1; i <dim; i++)
    {
      MPI_Recv(&T[i*dimloc], 1, MPI_INT, np-2, i,MPI_COMM_WORLD, status);
       for(j=1;j<dimloc;j++)
       {
//máximo de la fila y columna anterior
          int maximo=(T[(i-1)*dimloc+j]>T[i*dimloc+j-1]?T[(i-1)*dimloc+j]:T[i*dimloc+j-1]);
//si los elementos de las cadenas coinciden y añadiendo 1 al valor en la diagonal 
//anterior es mayor que el máximo, se actualiza
          if(C1[i-1]==C2[j-1] && T[(i-1)*dimloc+j-1]+1>maximo)
            maximo=T[(i-1)*dimloc+j-1]+1;
          T[i*dimloc+j]=maximo;
       }//for j
    }//for i
  } //if
  else 
  {
    for (i = 1; i <dim; i++)
    {
      MPI_Recv(&T[i*dimloc], 1, MPI_INT, nodo-1, i,MPI_COMM_WORLD, status);
       for(j=1;j<dimloc;j++)
       {
//máximo de la fila y columna anterior
          int maximo=(T[(i-1)*dimloc+j]>T[i*dimloc+j-1]?T[(i-1)*dimloc+j]:T[i*dimloc+j-1]);
//si los elementos de las cadenas coinciden y añadiendo 1 al valor en la diagonal 
//anterior es mayor que el máximo, se actualiza
          if(C1[i-1]==C2[j-1] && T[(i-1)*dimloc+j-1]+1>maximo)
            maximo=T[(i-1)*dimloc+j-1]+1;
          T[i*dimloc+j]=maximo;
       }//for j
       MPI_Send(&T[i*dimloc+dimloc-1], 1, MPI_INT, nodo+1,i, MPI_COMM_WORLD);
    }//for i
  } //if
#ifdef DEBUG
    escribirint(T,dim,dimloc);
#endif
//la longitud de la cadena más larga es el último valor en la tabla de programación dinámica
  if(nodo==0)
  {
      MPI_Recv(&resul, 1, MPI_INT, np-1, 0,MPI_COMM_WORLD, status);
  }
  else if(nodo==np-1)
  {
      MPI_Send(&T[dim*dimloc-1],1,MPI_INT,0,0,MPI_COMM_WORLD);
  } 
  free(T);
  if(nodo==0)
  {
    free(sendcount);
    free(senddisp);
  }
  else
  {
    free(C1);
    free(C2);
  }
  return resul;
}

